import { State } from './state';
import { commitSymbol, phaseSymbol, updateSymbol, effectsSymbol, Phase, EffectsSymbols } from './symbols';
import { GenericRenderer } from './core';
declare abstract class BaseScheduler<R extends GenericRenderer, H> {
    renderer: R;
    host: H;
    state: State<H>;
    [phaseSymbol]: Phase | null;
    _updateQueued: boolean;
    constructor(renderer: R, host: H);
    update(): void;
    handlePhase(phase: typeof commitSymbol, arg: unknown): void;
    handlePhase(phase: typeof updateSymbol): unknown;
    handlePhase(phase: typeof effectsSymbol): void;
    render(): unknown;
    runEffects(phase: EffectsSymbols): void;
    abstract commit(result: unknown): void;
    teardown(): void;
}
export { BaseScheduler };
